unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP,
  StdCtrls, Buttons, ComCtrls, IdCoder, IdCoder3to4, IdCoderMIME, OleCtrls,
  SHDocVw, IdIOHandler, IdIOHandlerStream, IdIOHandlerThrottle,
  IdIOHandlerSocket, IdSSLOpenSSL, IdSocks;

type
  TForm1 = class(TForm)
    IdHTTP1: TIdHTTP;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Edit3: TEdit;
    Memo1: TMemo;
    Edit4: TEdit;
    DateTimePicker1: TDateTimePicker;
    DateTimePicker2: TDateTimePicker;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    WebBrowser1: TWebBrowser;
    Label7: TLabel;
    Edit5: TEdit;
    BitBtn3: TBitBtn;
    BitBtnOk: TBitBtn;
    IdSSLIOHandlerSocket1: TIdSSLIOHandlerSocket;
    IdSocksInfo1: TIdSocksInfo;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    procedure BitBtn1Click(Sender: TObject);
    procedure Memo1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BitBtn2Click(Sender: TObject);
    procedure IdHTTP1Redirect(Sender: TObject; var dest: String;
      var NumRedirect: Integer; var Handled: Boolean;
      var VMethod: TIdHTTPMethod);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtnOkClick(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure WebBrowser1DocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure BitBtn7Click(Sender: TObject);
  private
    { Private declarations }
    gs_Auto : String;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses mshtml, ActiveX;

{$R *.DFM}

procedure TForm1.BitBtn1Click(Sender: TObject);
const
  ls_URL = 'http://sms.pchome.com.tw/TeleCom/MsgMgr';
var
  ls_Tag : String;
  lv_Body : Variant;
  lt_Tag : TStringList;
begin
  lt_Tag := TStringList.Create;

  try
    ls_Tag := IdHttp1.URL.PathEncode(Memo1.Lines.Text);
    lt_Tag.Values['firstClick'] := '0';
    lt_Tag.Values['payType'] := 'PChomeAPBW';
    lt_Tag.Values['mobile01'] := Edit3.Text;
    lt_Tag.Values['year'] := FormatDateTime('yyyy', DateTimePicker1.Date);
    lt_Tag.Values['month'] := FormatDateTime('mm', DateTimePicker1.Date);
    lt_Tag.Values['day'] := FormatDateTime('dd', DateTimePicker1.Date);
    lt_Tag.Values['hour'] := FormatDateTime('hh', DateTimePicker2.Time);
    lt_Tag.Values['minute'] := FormatDateTime('nn', DateTimePicker2.Time);
    lt_Tag.Values['InputMsg'] := ls_Tag;

    if RadioButton1.Checked then
      lt_Tag.Values['sendType'] := '1'
    else
      lt_Tag.Values['sendType'] := '2';

    IdHttp1.Request.ContentType := 'application/x-www-form-urlencoded';
    IdHttp1.HandleRedirects := True;
    IdHttp1.Host := ls_URL;
    lv_Body := VarArrayCreate([0, 0], varVariant);
    lv_Body[0] := IdHttp1.Post(ls_URL, lt_Tag);
//    WebBrowser1.Navigate('about:blank');
//    IHTMLDocument2(WebBrowser1.Document).write(pSafeArray(TVarData(lv_Body).VArray));
//    IHTMLDocument2(WebBrowser1.Document).close;
  finally
    lt_Tag.Free;
  end;
end;

procedure TForm1.Memo1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ls_msg : WideString;
  li_Len : Integer;
begin
  ls_msg := Memo1.Lines.Text;

  if Length(ls_msg) <> Length(Memo1.Lines.Text) then
    li_Len := 70
  else
    li_Len := 140;

  Edit4.Text := IntToStr(li_Len - Length(ls_msg));

  if StrToInt(Edit4.Text) < 0 then
    Memo1.Lines.Text := Copy(ls_msg, 1, li_Len);

  ls_msg := Memo1.Lines.Text;
  Edit4.Text := IntToStr(li_Len - Length(ls_msg));
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
Const
  ls_URL = 'http://sms.pchome.com.tw/front_end/Login?';
var
  ls_Tag : String;
  lv_Body : Variant;
begin
  ls_Tag := 'fuid=' + Edit1.Text
          + '&pwd=' + Edit2.Text
          + '&errPage=/front_end/sms';
  IdHttp1.Request.ContentType := 'application/x-www-form-urlencoded';
  IdHttp1.HandleRedirects := True;
  IdHttp1.Host := 'http://sms.pchome.com.tw/front_end/sms';
  lv_Body := VarArrayCreate([0, 0], varVariant);
  lv_Body[0] := IdHttp1.Get(ls_URL + ls_Tag);
//  WebBrowser1.Navigate('about:blank');
//  IHTMLDocument2(WebBrowser1.Document).write(pSafeArray(TVarData(lv_Body).VArray));
//  IHTMLDocument2(WebBrowser1.Document).close;
end;

procedure TForm1.IdHTTP1Redirect(Sender: TObject; var dest: String;
  var NumRedirect: Integer; var Handled: Boolean;
  var VMethod: TIdHTTPMethod);
begin
  ShowMessage(dest);
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
const
  ls_URL = 'https://ezpay.pchome.com.tw/auth_form_do';
var
  lv_Body : Variant;
  lt_Tag : TStringList;
begin
  lt_Tag := TStringList.Create;

  try
    lt_Tag.Values['auth_code'] := Edit5.Text;
    IdHttp1.Request.ContentType := 'application/x-www-form-urlencoded';
    IdHttp1.HandleRedirects := True;
    IdHttp1.Host := ls_URL;
    lv_Body := VarArrayCreate([0, 0], varVariant);
    lv_Body[0] := IdHttp1.Post(ls_URL, lt_Tag);
    WebBrowser1.Navigate('about:blank');
    IHTMLDocument2(WebBrowser1.Document).write(pSafeArray(TVarData(lv_Body).VArray));
    IHTMLDocument2(WebBrowser1.Document).close;
  finally
    lt_Tag.Free;
  end;
end;

procedure TForm1.BitBtnOkClick(Sender: TObject);
begin
  BitBtn1.Click;
  BitBtn2.Click;
  BitBtn3.Click;
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
var
  Docs, Edits : OleVariant;
begin
  if Sender = nil then
    gs_Auto := 'Send' // @, eoe
  else
    gs_Auto := ''; // nJ

  PageControl1.ActivePageIndex := 1;
  Docs  := WebBrowser1.Document;
  Edits := Docs.GetElementByID('fuid');
  Edits.Value := Edit1.Text;
  Edits := WebBrowser1.OleObject.Document.all.Item ('pwd', 0);
  Edits.Value := Edit2.Text;
  //nJ
  WebBrowser1.OleObject.Document.GetElementByID('submit').Click;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  WebBrowser1.Navigate('http://sms.pchome.com.tw/front_end/sms');
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
var
  Docs, Edits : OleVariant;
begin
  if gs_Auto = 'Send' then
    gs_Auto := 'Auth'; // e{
    
  PageControl1.ActivePageIndex := 1;
  Docs  := WebBrowser1.Document;
  Edits := Docs.GetElementByID('InputMsg');
  Edits.Value := Memo1.Lines.Text;
  Edits := WebBrowser1.OleObject.Document.all.Item ('mobile01', 0);
  Edits.Value := Edit3.Text;

  if RadioButton1.Checked then
  begin
    Edits := WebBrowser1.OleObject.Document.all.Item ('sendType', 0);
    Edits.Value := '1';
  end
  else
  begin
    Edits := WebBrowser1.OleObject.Document.all.Item ('sendType', 0);
    Edits.Value := '2';
    Edits := WebBrowser1.OleObject.Document.all.Item ('year', 0);
    Edits.Value := FormatDateTime('yyyy', DateTimePicker1.Date);
    Edits := WebBrowser1.OleObject.Document.all.Item ('month', 0);
    Edits.Value := FormatDateTime('mm', DateTimePicker1.Date);
    Edits := WebBrowser1.OleObject.Document.all.Item ('day', 0);
    Edits.Value := FormatDateTime('dd', DateTimePicker1.Date);
    Edits := WebBrowser1.OleObject.Document.all.Item ('hour', 0);
    Edits.Value := FormatDateTime('hh', DateTimePicker1.Date);
    Edits := WebBrowser1.OleObject.Document.all.Item ('minute', 0);
    Edits.Value := FormatDateTime('nn', DateTimePicker1.Date);
  end;

  Edits := Docs.forms.item(1, 0);
  // Docs.forms.item(n,0) 䤤 n NO n  form  0 }l, ᭱ѼƨS
  Edits.submit;
end;

procedure TForm1.BitBtn6Click(Sender: TObject);
var
  Docs, Edits : OleVariant;
begin
  gs_Auto := ''; // eN
  PageControl1.ActivePageIndex := 1;
  Docs  := WebBrowser1.Document;
  Docs := Docs.forms.item(0, 0);
  Edits := Docs.item('auth_code', 0);
  // Docs.item('name_tag', n) o̪ name_tag NO form ̪ܼƦW, n NPW٪ n Ӥ@ˬO 0 }l
  Edits.Value := Edit5.Text;
  Docs.submit;
end;

procedure TForm1.WebBrowser1DocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
  if gs_Auto = 'Send' then
    BitBtn4.Click
  else if gs_Auto = 'Auth' then
    BitBtn6.Click;
end;

procedure TForm1.BitBtn7Click(Sender: TObject);
begin
  BitBtn5Click(nil);
end;

end.
